// Test3.java
import java.awt.Graphics;
import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.Timer;
import java.util.ArrayList;


 class Panel3 extends JPanel
{
    ArrayList<Ball> balls = new ArrayList<Ball>();
    private Timer myTimer;
    Panel3()
    {
	balls.add(new Ball(80,100,Color.RED));
	balls.add(new Ball(160,70,Color.BLUE));
	balls.add(new Ball(100,70,Color.YELLOW));
	for (Ball b: balls) b.set_radius(6);
    }

    public void rotate(Ball b, double angle)
    {
	double x = b.px - 100;
	double y = b.py - 75;
	double phi = angle*Math.PI/180.0;
	double ct = Math.cos(phi);
	double st = Math.sin(phi);
	b.set_position(ct*x-st*y+100,st*x+ct*y+75);
    }
    
    public void startAnimation()
    {
	if (myTimer == null)
	{
	    myTimer = new Timer(50,new TimerHandler() );
	    myTimer.start();
	}
	else if (!myTimer.isRunning()) myTimer.restart();
    }
    
    public void stopAnimation()
    {
	myTimer.stop();
    }
	
    private class TimerHandler implements ActionListener
    {
	public void actionPerformed(ActionEvent actionevent)
	{
	    Ball b = balls.get(1);
	    rotate(b,3);
	    repaint();
	}
    }
    public void paintComponent(Graphics g)
    {
	super.paintComponent( g );
	for (Ball b: balls) b.draw(g);
    }
}

public class Test3 
{
    Panel3 panel;

    public static void main(String args[] )
    {
	Panel3 panel = new Panel3();
	JFrame application = new JFrame("Test3");
	application.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	application.add(panel);
	application.setSize(200,200);
	application.setVisible(true);
	panel.startAnimation();
    }
}